from rest_framework import generics


class MethodSerializerMixin:
    def get_serializer_class(self):
        method = self.request.method.lower()
        if method in self.method_serializers:
            return self.method_serializers.get(method)

        return self.serializer_class


class RetrieveCreateAPIView(MethodSerializerMixin,
                            generics.CreateAPIView,
                            generics.RetrieveAPIView,):
    pass
